﻿// Copyright 2009-2014 Oliver Sturm <oliver@sturmnet.org> All rights reserved. 

// A functional list datatype in F#:
type 'T List = E | L of 'T * 'T List

// And a few utility functions

// prepend a new value
let cons x l = L(x, l)

// append one list to another, using a recursive approach
let rec append l1 l2 = 
    match l1 with
    | E -> l2
    | L(h, t) -> cons h (append t l2)

// drop the front element
let drop = function
    | E -> E
    | L(_, t) -> t

// -----------------

// instantiating a list of ints:

let ints = L(10, L(20, L(30, E)))

let rec output = function
    | E -> printfn ""
    | L(h,t) -> printf "%A " h ; output t

output ints

output (cons 55 ints)

output (append ints (L(40, L(50, E))))

let newlist = drop ints

output newlist

